SystemOrganization addCategory: #ConfigurationOfLRSTM!

Object subclass: #BenchmarkInitialization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfLRSTM'!

!BenchmarkInitialization methodsFor: 'benchmark configurations' stamp: 'StefanMarr 7/7/2013 22:44'!
benchmarksLRSTMKernel
	| harness bench |
	harness := 'SMarkHarness'.
	bench   := 'LRSTMBenchmarkGameSuite.benchAtomic'.
	^ {
 { harness. bench,'BinaryTrees'.   '1'. '1'. '4'}.
 { harness. bench,'Fasta'.         '1'. '1'. '10'.}.
 { harness. bench,'FannkuchRedux'. '1'. '1'. '3'.}.
 { harness. bench,'NBody'.         '1'. '1'. '40'.}.
 { harness. bench,'Mandelbrot'.    '1'. '1'. '200'.}.
 { harness. bench,'KNucleotide'.   '1'. '1'. '100'.}.
 { harness. bench,'Meteor'.        '1'. '1'. '2098'.}.
 { harness. bench,'PiDigits'.      '1'. '1'. '27'.}.
 { harness. bench,'ReverseComplement'. '1'. '1'. '1000'.}.
 { harness. bench,'SpectralNorm'.  '1'. '1'. '100'.}

 "Not properly supported with all the synchronization and processes: "
 "{ harness. bench,ChameneosRedux'. '1'. '1'. '1'.}."
 
 "Not supported, #perform would need to be replaced by #baselevelPerform that makes sure that the omnified selector is called."
 "{ harness. bench,RegexDNA'. '1'. '1'. '10'.}.
  { harness. 'LRSTMBenchCompiler.benchCompiler'. '1'. '30'.}."
}! !

!BenchmarkInitialization methodsFor: 'benchmark configurations' stamp: 'StefanMarr 7/7/2013 22:01'!
benchmarksLRSTMMicro
	| harness bench |
	harness := 'SMarkHarness'.
	bench   := 'LRSTMBenchLoops.benchAtomic'.
	^ {
 { harness. bench,'ArrayAccess'.           '1'. '1'. '40'.}.
 { harness. bench,'ClassVarBinding'.       '1'. '1'. '40'.}.
 { harness. bench,'FloatLoop'.             '1'. '1'. '40'.}.
 { harness. bench,'InstVarAccess'.         '1'. '1'. '40'.}.
 { harness. bench,'IntLoop'.               '1'. '1'. '40'.}.
 { harness. bench,'Send'.                  '1'. '1'. '40'.}.
 { harness. bench,'SendWithManyArguments'. '1'. '1'. '40'.}.
}! !

!BenchmarkInitialization methodsFor: 'script' stamp: 'StefanMarr 7/10/2013 17:39'!
omnifyBenchmarks
	BGFastaCache primeForFasta: 100.
	BGFastaCache primeForFasta: 1000.

	(self benchmarksLRSTMMicro,
	 self benchmarksLRSTMKernel) do: [:cfg |
		SMarkHarness run: cfg.
		Smalltalk garbageCollect
	] displayingProgress: 'Preparing Benchmarks'.
! !

!BenchmarkInitialization methodsFor: 'script' stamp: 'StefanMarr 7/10/2013 17:43'!
prepareImage
	LRSTMCompiler disableErrorOnMissingAtomicMethod.
	LRSTMCompiler flushAllAtomicMethods.
	
	LRSTMCompiler initializeLRSTM.
	
	self recompileSystem.
	self omnifyBenchmarks.
	
	LRSTMCompiler errorOnMissingAtomicMethod.! !

!BenchmarkInitialization methodsFor: 'script' stamp: 'StefanMarr 7/10/2013 17:42'!
recompileSystem
	(#(O LRSTM  CLBG)
		gather: [:name | (PackageInfo named: name) classes ])
		do: [:c | c compileAll]
		displayingProgress: 'Recompiling with LRSTMCompiler support enabled'.

	Smalltalk garbageCollect.! !

Object subclass: #ConfigurationOfLRSTM
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfLRSTM'!

!ConfigurationOfLRSTM class methodsFor: 'development support' stamp: 'StefanMarr 12/4/2011 13:25'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfLRSTM class methodsFor: 'private' stamp: 'StefanMarr 12/4/2011 13:25'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfLRSTM class methodsFor: 'private' stamp: 'StefanMarr 12/4/2011 13:25'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfLRSTM class methodsFor: 'private' stamp: 'StefanMarr 12/4/2011 13:25'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfLRSTM class methodsFor: 'metacello tool support' stamp: 'StefanMarr 12/4/2011 13:25'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfLRSTM class methodsFor: 'loading' stamp: 'StefanMarr 12/4/2011 13:25'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfLRSTM class methodsFor: 'loading' stamp: 'StefanMarr 12/4/2011 13:25'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfLRSTM class methodsFor: 'loading' stamp: 'StefanMarr 12/4/2011 13:25'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfLRSTM class methodsFor: 'loading' stamp: 'StefanMarr 2/4/2014 18:35'!
loadLocal
	"Load the latest versions of the mcz files defined for this project."

	"self loadLocal"

	<apiDocumentation>
	| version result |
	version := self project version: #bleedingEdge.
	version repositoryOverrides: { MCDirectoryRepository new directory: ('/Users/smarr/Projects/monticello.repo' asFileReference) }.

	self preLoadScript.
	result := version load.
	self postLoadScript.
	^ result! !

!ConfigurationOfLRSTM class methodsFor: 'loading' stamp: 'StefanMarr 1/13/2013 20:48'!
loadPhD2013
	"This configuration reflects the project status used for benchmarks in my PhD dissertation"

	"self loadPhD2013"

	<apiDocumentation>
	^(self project version: #'phd2013') load! !

!ConfigurationOfLRSTM class methodsFor: 'loading' stamp: 'StefanMarr 1/15/2012 22:48'!
loadTOOLS2012
	"This configuration represents the state of the project used for the initial paper submission
	 for TOOLS 2012"

	"self loadTOOLS2012"

	<apiDocumentation>
	^(self project version: #'tools2012') load! !

!ConfigurationOfLRSTM class methodsFor: 'scripts' stamp: 'StefanMarr 7/10/2013 17:40'!
postLoadScript
	
	(Smalltalk globals at: #LRSTMTransaction) initializeLRSTM.
	(Smalltalk globals at: #LRSTMCompiler   ) initializeLRSTM.
	
	Process class removeSelector: #shouldNotBeRedefined.
	
	BenchmarkInitialization new prepareImage.! !

!ConfigurationOfLRSTM class methodsFor: 'scripts' stamp: 'StefanMarr 6/11/2013 19:21'!
preLoadScript
	"Disable warning"
	self assert: (Process class includesLocalSelector: #shouldNotBeRedefined) not.
	
	Process class compileSilently: 'shouldNotBeRedefined ^ false' classified: '' notifying: nil.! !

!ConfigurationOfLRSTM class methodsFor: 'accessing' stamp: 'StefanMarr 12/4/2011 13:25'!
project

	^self new project! !

!ConfigurationOfLRSTM class methodsFor: 'transporter' stamp: 'StefanMarr 12/4/2011 13:25'!
saveWithTransporter
	"Will save the package in file-out format using the Transporter infrastructure"
	self transporters
		ifNotNilDo: [:transporters | 
			transporters do: [:t | t saveNoPopup ]].! !

!ConfigurationOfLRSTM class methodsFor: 'transporter' stamp: 'StefanMarr 12/4/2011 13:25'!
subPackages
	"Specifies the names of all logical subpackages of the Benchmarking package."
	"TODO: have a versioning for this, to better comply with the Metacello approach."
	^ {	'SMark'.
		'Scripting'.
		'NPB'.
		'CL-Benchmarks-Game'.
	}! !

!ConfigurationOfLRSTM class methodsFor: 'transporter' stamp: 'StefanMarr 12/4/2011 13:25'!
transporters
	"Returns the transporters that define how to file out the different packages for versioning with Git."
	Smalltalk globals at: #Transporter ifPresent: [ :tpCls |
		^ self subPackages collect: [:pkg | tpCls forPackage: (PackageInfo named: pkg) ]
	].
	
	" Else "
	^ nil.! !

!ConfigurationOfLRSTM class methodsFor: 'transporter' stamp: 'StefanMarr 12/4/2011 13:25'!
transportersForFileOutMenu
	^ self transporters! !

!ConfigurationOfLRSTM class methodsFor: 'development support' stamp: 'StefanMarr 12/4/2011 13:25'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfLRSTM methodsFor: 'baselines' stamp: 'StefanMarr 1/15/2012 22:46'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
				
		"AST-Compiler (RBCompiler)"
		spec package: 'AST-Compiler' with: [
				spec repository: 'http://source.lukas-renggli.ch/helvetia'].
		
		"SMark Benchmarking"
		spec project: 'Benchmarking'
			with:
				[ spec
					className: 'ConfigurationOfBenchmarking';
					file: 'ConfigurationOfBenchmarking';
					repository: 'http://www.squeaksource.com/SMark' ].

		"LRSTM"
		spec
			repository: 'http://ss3.gemstone.com/ss/LRSTM';
			package: 'LRSTMPrerequisites';
			package: 'LRSTM' with: [
				spec requires: #('AST-Compiler' 'Benchmarking' 'LRSTMPrerequisites')].
		
		"Omni Benchmarks"
		spec
			repository: 'http://ss3.gemstone.com/ss/Omni';
			package: 'OmniST-Benchmarks' with: [
				spec requires: #('LRSTM')]
	].! !

!ConfigurationOfLRSTM methodsFor: 'baselines' stamp: 'StefanMarr 1/13/2013 20:44'!
baseline03: spec
	<version: '0.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		
		"AST Basis"
		spec package: 'AST-Core' with: [
				spec repository: 'http://www.squeaksource.com/rb'].
		spec package: 'AST-Semantic' with: [
				spec
					repository: 'http://www.squeaksource.com/rb';
					requires: #('AST-Core')].
		
		
		"AST-Compiler (RBCompiler)"
		spec package: 'AST-Compiler' with: [
				spec repository: 'http://source.lukas-renggli.ch/helvetia';
					requires: #('AST-Core' 'AST-Semantic')].
		
		"SMark Benchmarking"
		spec project: 'Benchmarking'
			with:
				[ spec
					className: 'ConfigurationOfBenchmarking';
					versionString: '0.2';
					repository: 'http://www.squeaksource.com/SMark' ].

		"LRSTM"
		spec
			repository: 'http://ss3.gemstone.com/ss/LRSTM';
			package: 'LRSTMPrerequisites';
			
			package: 'LRSTM-Core' with: [
				spec requires: #('AST-Compiler' 'Benchmarking' 'LRSTMPrerequisites')].
		
		spec package: 'CLBG-Compatibility' with: [
			spec
				repository: 'http://ss3.gemstone.com/ss/Omni';
				requires: #('LRSTM-Core')].
		
		spec
			repository: 'http://ss3.gemstone.com/ss/LRSTM';		
			package: 'LRSTM-Benchmarks' with: [
				spec requires: #('LRSTM-Core' Benchmarking 'CLBG-Compatibility')];
			package: 'LRSTM-Tests' with: [
				spec
					preLoadDoIt: #hackDefineGlobalToWorkaroundRBCompilerIssues;
					requires: #('LRSTM-Core')].

	].! !

!ConfigurationOfLRSTM methodsFor: 'baselines' stamp: 'StefanMarr 2/4/2014 18:55'!
baseline04: spec
	<version: '0.4-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		
		"SMark Benchmarking"
		spec project: 'Benchmarking' with:	[
			spec className: 'ConfigurationOfBenchmarking';
				  versionString: #'bleedingEdge';
				  repository: 'http://smalltalkhub.com/mc/StefanMarr/SMark/main' ].

		"LRSTM"
		spec
			repository: 'http://ss3.gemtalksystems.com/ss/LRSTM';
			package: 'LRSTMPrerequisites';
			package: 'LRSTM-Model';
			package: 'LRSTM-Core' with: [
				spec requires: #('Benchmarking' 'LRSTMPrerequisites' 'LRSTM-Model')].
		
		spec
			repository: 'http://ss3.gemtalksystems.com/ss/Omni';
			package: 'O-Base-Compat';
			package: 'O-Base-Overrides';
			package: 'O-Core-Misc' with: 'O-Core-Misc.NoOwner-StefanMarr.8'.

		spec package: 'O-CLBG-Compatibility' with: [
			spec repository: 'http://ss3.gemtalksystems.com/ss/Omni';
			     file: 'O-CLBG-Compatibility.NoOwner-StefanMarr.8';
			     requires: #('Benchmarking' 'O-Core-Misc')].
		
		spec
			repository: 'http://ss3.gemtalksystems.com/ss/LRSTM';		
			package: 'LRSTM-Benchmarks' with: [
				spec requires: #('LRSTM-Core' Benchmarking 'O-CLBG-Compatibility')];
			package: 'LRSTM-Tests' with: [
				spec
					preLoadDoIt: #hackDefineGlobalToWorkaroundRBCompilerIssues;
					requires: #('LRSTM-Core')].

	].! !

!ConfigurationOfLRSTM methodsFor: 'symbolic versions' stamp: 'StefanMarr 1/13/2013 20:47'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.4-baseline'.
! !

!ConfigurationOfLRSTM methodsFor: 'preload-hack' stamp: 'StefanMarr 1/13/2013 20:09'!
hackDefineGlobalToWorkaroundRBCompilerIssues
	Smalltalk at: #GlobalValue put: nil! !

!ConfigurationOfLRSTM methodsFor: 'symbolic versions' stamp: 'StefanMarr 1/13/2013 20:40'!
phd2013: spec
	<symbolicVersion: #'phd2013'>

	spec for: #'common' version: '0.3-phd2013'.
! !

!ConfigurationOfLRSTM methodsFor: 'accessing' stamp: 'StefanMarr 12/4/2011 13:25'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfLRSTM methodsFor: 'symbolic versions' stamp: 'StefanMarr 1/15/2012 22:42'!
tools2012: spec
	<symbolicVersion: #'tools2012'>

	spec for: #'common' version: '0.2-tools2012'.
! !

!ConfigurationOfLRSTM methodsFor: 'versions' stamp: 'StefanMarr 12/4/2011 13:30'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'StefanMarr'.
		spec timestamp: '2011-12-04 12:19'.
	].! !

!ConfigurationOfLRSTM methodsFor: 'versions' stamp: 'StefanMarr 1/15/2012 22:44'!
version02: spec
	<version: '0.2-tools2012' imports: #('0.1-baseline') >

	spec for: #'common' do: [
		spec blessing: #'tools2012'.
		spec description: 'Configuration reflecting the project status used for the initial TOOLS2012 submission'.
		spec author: 'StefanMarr'.
		spec timestamp: '1/15/2012 22:40'.
	
		spec
			package: 'AST-Compiler' 		with: 'AST-Compiler-lr.37';
			package: 'LRSTMPrerequisites' with: 'LRSTMPrerequisites-StefanMarr.1';
			package: 'LRSTM' 				with: 'LRSTM-StefanMarr.30';
			package: 'OmniST-Benchmarks'	with: 'OmniST-Benchmarks-StefanMarr.5'
	].! !

!ConfigurationOfLRSTM methodsFor: 'versions' stamp: 'StefanMarr 1/13/2013 20:47'!
version03: spec
	<version: '0.3-phd2013' imports: #('0.3-baseline') >

	spec for: #'common' do: [
		spec blessing: #'phd2013'.
		spec description: 'Configuration reflecting the project status used for the benchmarks of my PhD'.
		spec author: 'StefanMarr'.
		spec timestamp: '1/13/2013 20:41'.
	
		spec
			package: 'AST-Compiler' 		with: 'AST-Compiler-lr.37';
			package: 'LRSTMPrerequisites' with: 'LRSTMPrerequisites-StefanMarr.1';
			package: 'LRSTM-Core'			with: 'LRSTM-Core-StefanMarr.3';
          package: 'CLBG-Compatibility'	with: 'CLBG-Compatibility-StefanMarr.1';
			package: 'LRSTM-Benchmarks'	with: 'LRSTM-Benchmarks-StefanMarr.1';
			package: 'LRSTM-Tests'			with: 'LRSTM-Tests-StefanMarr.1'
	].! !
